on checkRange originalNumber, minValue, maxValue
  if minValue > maxValue then
    set x to minValue
    set minValue to maxValue
    set maxValue to x
  end if
  if originalNumber < minValue then
    set originalNumber to minValue
  else
    if originalNumber > maxValue then
      set originalNumber to maxValue
    end if
  end if
  return originalNumber
end

on checkRangeWrap originalNumber, minValue, maxValue
  if minValue > maxValue then
    set x to minValue
    set minValue to maxValue
    set maxValue to x
  end if
  if originalNumber < minValue then
    repeat while originalNumber < minValue
      set originalNumber to maxValue - (minValue - originalNumber) + 1
    end repeat
  else
    if originalNumber > maxValue then
      repeat while originalNumber > maxValue
        set originalNumber to minValue + (originalNumber - maxValue) - 1
      end repeat
    end if
  end if
  return originalNumber
end

on getRect whichSprite
  if the type of sprite whichSprite > 0 then
    set spriteLeft to the left of sprite whichSprite
    set spriteTop to the top of sprite whichSprite
    set spriteRight to the right of sprite whichSprite
    set spriteBottom to the bottom of sprite whichSprite
    return rect(spriteLeft, spriteTop, spriteRight, spriteBottom)
  else
    return 0
  end if
end

on setProp startSprite, stopSprite, whichProperty, whichValue
  repeat with x = startSprite to stopSprite
    do("set the " & whichProperty & " of sprite x=whichValue")
  end repeat
end

on setQTProp startSprite, stopSprite, whichProperty, whichValue
  repeat with x = startSprite to stopSprite
    if the type of sprite x > 0 then
      if the castType of cast the castNum of sprite x = #digitalVideo then
        do("set the " & whichProperty & " of sprite x=whichValue")
      end if
    end if
  end repeat
end

on pupSound whichSound
  global gPupSound
  if (gPupSound <> whichSound) or not (the soundBusy of 1) then
    set gPupSound to whichSound
    puppetSound(whichSound)
  end if
end

on playSound whichSound
  set whichCast to the number of cast whichSound
  if whichCast > 0 then
    puppetSound(whichSound)
    updateStage()
    repeat while the soundBusy of 1
      updateStage()
    end repeat
    puppetSound(0)
  end if
end

on playSoundOnly whichSound
  sound stop 1
  set soundCast to the number of cast whichSound
  if soundCast > 0 then
    puppetSound(whichSound)
    updateStage()
    repeat while the soundBusy of 1
      if the commandDown then
        exit repeat
      end if
    end repeat
    puppetSound(0)
  end if
end

on soundPlayFile whichChannel, whichSound
  sound stop whichChannel
  puppetSound(0)
  updateStage()
  sound playFile whichChannel, whichSound
end

on delayFor howLong, interrupt
  set howLong to howLong + the timer
  if voidp(interrupt) then
    repeat while the timer < howLong
      nothing()
    end repeat
  else
    repeat while (the timer < howLong) and the mouseUp
      nothing()
    end repeat
    if interrupt > 0 then
      puppetTransition(0)
      go(interrupt)
    end if
  end if
end

on developersKey
  return the shiftDown and the controlDown
end

on commandKey
  if the machineType = 256 then
    return the controlDown
  else
    return the commandDown
  end if
end

on showNames startCast, endCast
  if length(string(startCast)) = 0 then
    set startCast to 1
    set endCast to the number of cast "castNameList" - 1
  end if
  set castNameList to EMPTY
  repeat with x = startCast to endCast
    set castNameList to castNameList & x & "," & the name of cast x & RETURN
  end repeat
  set the text of cast "castNameList" to castNameList
end

on setNames startCast, endCast
  if length(string(startCast)) = 0 then
    set startCast to 1
    set endCast to the number of cast "castNameList" - 1
  end if
  set castNameList to the text of cast "castNameList"
  repeat with x = 1 to the number of lines in castNameList
    set whichCast to value(item 1 of line x of castNameList)
    set whichName to item 2 to 100 of line x of castNameList
    if whichName <> EMPTY then
      if whichName <> "0" then
        set the name of cast whichCast to whichName
      end if
    end if
  end repeat
  set the text of cast "castNameList" to castNameList
end

on findCenter whichSprite1, whichSprite2
  put ((the left of sprite whichSprite2 - the right of sprite whichSprite1) / 2) + the right of sprite whichSprite1
end
